package com.kwei.HN_Sync;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.json.JSONArray;
import org.json.JSONObject;

import com.kwei.HN_Sync.R;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class Main extends Activity implements OnClickListener {
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        setTheme(android.R.style.Theme_Holo_Light);
        //findViewById(R.id.my_button).setOnClickListener(this);
    }
    
    @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.mainmenu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.refresh:
			Toast.makeText(this, "Refreshing", Toast.LENGTH_SHORT)
					.show();
			new FetchHomepageItems().execute();
			break;
		case R.id.menuitem2:
			Toast.makeText(this, "Menu item 2 selected", Toast.LENGTH_SHORT)
					.show();
			break;

		default:
			break;
		}

		return true;
	}

	@Override
	public void onClick(View arg0) {
		return;
	}
	
	private class FetchHomepageItems extends AsyncTask <Void, Void, String> {
		
		//"http://hndroidapi.appspot.com/news/format/json/page/?appid=HN_Sync"
		@Override
		protected String doInBackground(Void... params) {
			StringBuilder builder = new StringBuilder();
			HttpClient client = new DefaultHttpClient();
			HttpGet httpGet = new HttpGet("http://hndroidapi.appspot.com/news/format/json/page/?appid=HN_Sync");
			try {
				HttpResponse response = client.execute(httpGet);
				StatusLine statusLine = response.getStatusLine();
				int statusCode = statusLine.getStatusCode();
				if (statusCode == 200) {
					HttpEntity entity = response.getEntity();
					InputStream content = entity.getContent();
					BufferedReader reader = new BufferedReader(new InputStreamReader(content));
					String line;
					while ((line = reader.readLine()) != null) {
						builder.append(line);
						System.out.print(line);
					}
				} else {
					Log.e(Main.class.toString(), "Failed to download file");
				}
			} catch (ClientProtocolException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return builder.toString();
		}	
		
		protected void onPostExecute(String results) {
			if (results!=null) {
				try {
					JSONObject jsonArray = new JSONObject(results);
					Log.i(Main.class.getName(),
							"Number of entries " + jsonArray.length());
					
						JSONArray jsonObject = jsonArray.optJSONArray("items");
					for (int i = 0; i < jsonObject.length(); i++) {	
						Log.i(Main.class.getName(), jsonObject.optString(0));
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
				
				
				EditText et = (EditText)findViewById(R.id.my_edit);
				et.setText(results);
			}
			//Button b = (Button)findViewById(R.id.my_button);
			//b.setClickable(true);
		}
    }
}